`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: Quenne Electric
// Engineer: Andras Bognar
// 
// Create Date:    20:35:17 05/18/2007 
// Design Name: 		RS232 transmitter
// Module Name:    transmitter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module transmitter(CLK, DATA, TRMT, OUT, INPROC);
	 input CLK;
    input [7:0] DATA;
    input TRMT;			//start transmit
    output OUT;			//TxD
	 output INPROC;		//transmit in process

	reg [10:0]shdata=0;	//shift reg.
	reg [1:0]div=0;	 	//clock divider (/3)
	reg trans=0;		 	//ads flag
	reg [3:0]bitsz=0;		//bitszmll
	reg [1:0]monst=0;		//monostabil MV shift reg. (transmit indtsa)
		
	always@(posedge CLK)
		begin
		monst[0]<=TRMT;				//monostabil MV
		monst[1]<=monst[0];
		
		if((trans==0)&&(monst==2'b01))//init transmit
			begin
			div<=2'h0;
			shdata[8:1]<=DATA;
			shdata[9]<=0;
			shdata[0]<=1;
			bitsz<=4'h0;
			end

		if(monst==2'b01)				//init transmit
			begin
			trans=1;
			end
		else								//transmit
			begin
			div<=div+1;
			if(div==2'h2)div<=2'h0;
			if(trans==1)
				begin
				if(div==2'h2)
					begin
					shdata[10:1]<=shdata[9:0];
					bitsz<=bitsz+1;
					if(bitsz==4'hA)trans=0;
					end
				end
			else shdata[10]<=1;
			end
		end
		
		assign OUT=shdata[10];
		assign INPROC=trans;

endmodule
